﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using NLog;
using NLog.Config;
using NLog.Fluent;

namespace NLogStudy.ConsoleApp.Default
{
    public class NLogBox
    {
        public Logger  Logger;
        public NLogBox()
        {
            Logger = NLog.LogManager.GetCurrentClassLogger();
        }

        public static LoggingConfiguration GetConfig()
        {
            LoggingConfiguration configuration = new LoggingConfiguration();

            // Targets where to log to: File and Console
            var logfile = new NLog.Targets.FileTarget("logfile") { FileName = "file.txt" };
            var logconsole = new NLog.Targets.ConsoleTarget("logconsole");

            // Rules for mapping loggers to targets            
            configuration.AddRule(LogLevel.Info, LogLevel.Fatal, logconsole);
            configuration.AddRule(LogLevel.Debug, LogLevel.Fatal, logfile);

            return configuration;
        }
    }
}
